diff --git a/usr.sbin/mtree/specspec.c b/usr.sbin/mtree/specspec.c
new file mode 100644
index 0000000000..149e7a3078
--- /dev/null
+++ b/usr.sbin/mtree/specspec.c
@@ -0,0 +1,273 @@
+/*	$NetBSD: specspec.c,v 1.4 2017/12/14 18:34:41 christos Exp $	*/
+
+/*-
+ * Copyright (c) 2003 Poul-Henning Kamp
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#endif
+
+#include <sys/cdefs.h>
+__RCSID("$NetBSD: specspec.c,v 1.4 2017/12/14 18:34:41 christos Exp $");
+
+#include <err.h>
+#include <grp.h>
+#include <pwd.h>
+#include <time.h>
+#include <stdio.h>
+#include <stdint.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include "mtree.h"
+#include "extern.h"
+
+#define FF(a, b, c, d) \
+	(((a)->flags & (c)) && ((b)->flags & (c)) && ((a)->d) != ((b)->d))
+#define FS(a, b, c, d) \
+	(((a)->flags & (c)) && ((b)->flags & (c)) && strcmp((a)->d,(b)->d))
+#define FM(a, b, c, d) \
+	(((a)->flags & (c)) && ((b)->flags & (c)) && memcmp(&(a)->d,&(b)->d, sizeof (a)->d))
+
+static void
+shownode(NODE *n, int f, char const *path)
+{
+	struct group *gr;
+	struct passwd *pw;
+
+	printf("%s%s %s", path, n->name, inotype(nodetoino(n->type)));
+	if (f & F_CKSUM)
+		printf(" cksum=%lu", n->cksum);
+	if (f & F_GID)
+		printf(" gid=%d", n->st_gid);
+	if (f & F_GNAME) {
+		gr = getgrgid(n->st_gid);
+		if (gr == NULL)
+			printf(" gid=%d", n->st_gid);
+		else
+			printf(" gname=%s", gr->gr_name);
+	}
+	if (f & F_MODE)
+		printf(" mode=%o", n->st_mode);
+	if (f & F_NLINK)
+		printf(" nlink=%ju", (uintmax_t)n->st_nlink);
+	if (f & F_SIZE)
+		printf(" size=%jd", (intmax_t)n->st_size);
+	if (f & F_UID)
+		printf(" uid=%d", n->st_uid);
+	if (f & F_UNAME) {
+		pw = getpwuid(n->st_uid);
+		if (pw == NULL)
+			printf(" uid=%d", n->st_uid);
+		else
+			printf(" uname=%s", pw->pw_name);
+	}
+	if (f & F_MD5)
+		printf(" %s=%s", MD5KEY, n->md5digest);
+	if (f & F_SHA1)
+		printf(" %s=%s", SHA1KEY, n->sha1digest);
+	if (f & F_RMD160)
+		printf(" %s=%s", RMD160KEY, n->rmd160digest);
+	if (f & F_SHA256)
+		printf(" %s=%s", SHA256KEY, n->sha256digest);
+	if (f & F_SHA384)
+		printf(" %s=%s", SHA384KEY, n->sha384digest);
+	if (f & F_SHA512)
+		printf(" %s=%s", SHA512KEY, n->sha512digest);
+	if (f & F_FLAGS)
+		printf(" flags=%s", flags_to_string(n->st_flags, "none"));
+	printf("\n");
+}
+
+static int
+mismatch(NODE *n1, NODE *n2, int differ, char const *path)
+{
+
+	if (n2 == NULL) {
+		shownode(n1, differ, path);
+		return (1);
+	}
+	if (n1 == NULL) {
+		printf("\t");
+		shownode(n2, differ, path);
+		return (1);
+	}
+	if (!(differ & keys))
+		return(0);
+	printf("\t\t");
+	shownode(n1, differ, path);
+	printf("\t\t");
+	shownode(n2, differ, path);
+	return (1);
+}
+
+static int
+compare_nodes(NODE *n1, NODE *n2, char const *path)
+{
+	int differs;
+	
+	if (n1 != NULL && n1->type == F_LINK)
+		n1->flags &= ~F_MODE;
+	if (n2 != NULL && n2->type == F_LINK)
+		n2->flags &= ~F_MODE;
+	differs = 0;
+	if (n1 == NULL && n2 != NULL) {
+		differs = n2->flags;
+		mismatch(n1, n2, differs, path);
+		return (1);
+	}
+	if (n1 != NULL && n2 == NULL) {
+		differs = n1->flags;
+		mismatch(n1, n2, differs, path);
+		return (1);
+	}
+	if (n1->type != n2->type) {
+		differs = 0;
+		mismatch(n1, n2, differs, path);
+		return (1);
+	}
+	if (FF(n1, n2, F_CKSUM, cksum))
+		differs |= F_CKSUM;
+	if (FF(n1, n2, F_GID, st_gid))
+		differs |= F_GID;
+	if (FF(n1, n2, F_GNAME, st_gid))
+		differs |= F_GNAME;
+	if (FF(n1, n2, F_MODE, st_mode))
+		differs |= F_MODE;
+	if (FF(n1, n2, F_NLINK, st_nlink))
+		differs |= F_NLINK;
+	if (FF(n1, n2, F_SIZE, st_size))
+		differs |= F_SIZE;
+	if (FS(n1, n2, F_SLINK, slink))
+		differs |= F_SLINK;
+	if (FM(n1, n2, F_TIME, st_mtimespec))
+		differs |= F_TIME;
+	if (FF(n1, n2, F_UID, st_uid))
+		differs |= F_UID;
+	if (FF(n1, n2, F_UNAME, st_uid))
+		differs |= F_UNAME;
+	if (FS(n1, n2, F_MD5, md5digest))
+		differs |= F_MD5;
+	if (FS(n1, n2, F_SHA1, sha1digest))
+		differs |= F_SHA1;
+	if (FS(n1, n2, F_RMD160, rmd160digest))
+		differs |= F_RMD160;
+	if (FS(n1, n2, F_SHA256, sha256digest))
+		differs |= F_SHA256;
+	if (FS(n1, n2, F_SHA384, sha384digest))
+		differs |= F_SHA384;
+	if (FS(n1, n2, F_SHA512, sha512digest))
+		differs |= F_SHA512;
+	if (FF(n1, n2, F_FLAGS, st_flags))
+		differs |= F_FLAGS;
+	if (differs) {
+		mismatch(n1, n2, differs, path);
+		return (1);
+	}
+	return (0);	
+}
+static int
+walk_in_the_forest(NODE *t1, NODE *t2, char const *path)
+{
+	int r, i;
+	NODE *c1, *c2, *n1, *n2;
+	char *np;
+
+	r = 0;
+
+	if (t1 != NULL)
+		c1 = t1->child;
+	else
+		c1 = NULL;
+	if (t2 != NULL)
+		c2 = t2->child;
+	else
+		c2 = NULL;
+	while (c1 != NULL || c2 != NULL) {
+		n1 = n2 = NULL;
+		if (c1 != NULL)
+			n1 = c1->next;
+		if (c2 != NULL)
+			n2 = c2->next;
+		if (c1 != NULL && c2 != NULL) {
+			if (c1->type != F_DIR && c2->type == F_DIR) {
+				n2 = c2;
+				c2 = NULL;
+			} else if (c1->type == F_DIR && c2->type != F_DIR) {
+				n1 = c1;
+				c1 = NULL;
+			} else {
+				i = strcmp(c1->name, c2->name);
+				if (i > 0) {
+					n1 = c1;
+					c1 = NULL;
+				} else if (i < 0) {
+					n2 = c2;
+					c2 = NULL;
+				}
+			}
+		}
+		if (c1 == NULL && c2->type == F_DIR) {
+			asprintf(&np, "%s%s/", path, c2->name);
+			i = walk_in_the_forest(c1, c2, np);
+			free(np);
+			i += compare_nodes(c1, c2, path);
+		} else if (c2 == NULL && c1->type == F_DIR) {
+			asprintf(&np, "%s%s/", path, c1->name);
+			i = walk_in_the_forest(c1, c2, np);
+			free(np);
+			i += compare_nodes(c1, c2, path);
+		} else if (c1 == NULL || c2 == NULL) {
+			i = compare_nodes(c1, c2, path);
+		} else if (c1->type == F_DIR && c2->type == F_DIR) {
+			asprintf(&np, "%s%s/", path, c1->name);
+			i = walk_in_the_forest(c1, c2, np);
+			free(np);
+			i += compare_nodes(c1, c2, path);
+		} else {
+			i = compare_nodes(c1, c2, path);
+		}
+		r += i;
+		c1 = n1;
+		c2 = n2;
+	}
+	return (r);	
+}
+
+int
+mtree_specspec(FILE *fi, FILE *fj)
+{
+	int rval;
+	NODE *root1, *root2;
+
+	root1 = spec(fi);
+	root2 = spec(fj);
+	rval = walk_in_the_forest(root1, root2, "");
+	rval += compare_nodes(root1, root2, "");
+	if (rval > 0)
+		return (MISMATCHEXIT);
+	return (0);
+}
diff --git a/usr.sbin/mtree/stat_flags.c b/usr.sbin/mtree/stat_flags.c
new file mode 100644
index 0000000000..5724370b3e
--- /dev/null
+++ b/usr.sbin/mtree/stat_flags.c
@@ -0,0 +1,187 @@
+/*	$NetBSD: stat_flags.c,v 1.2 2007/01/16 17:34:02 cbiere Exp $	*/
+
+/*-
+ * Copyright (c) 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#else
+#define HAVE_STRUCT_STAT_ST_FLAGS 1
+#endif
+
+#include <sys/cdefs.h>
+#if !defined(lint)
+#if 0
+static char sccsid[] = "@(#)stat_flags.c	8.2 (Berkeley) 7/28/94";
+#else
+__RCSID("$NetBSD: stat_flags.c,v 1.2 2007/01/16 17:34:02 cbiere Exp $");
+#endif
+#endif /* not lint */
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <fts.h>
+#include <stddef.h>
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+
+#include "extern.h"
+
+#define	SAPPEND(s) do {							\
+	if (prefix != NULL)						\
+		(void)strlcat(string, prefix, sizeof(string));		\
+	(void)strlcat(string, s, sizeof(string));			\
+	prefix = ",";							\
+} while (/* CONSTCOND */ 0)
+
+/*
+ * flags_to_string --
+ *	Convert stat flags to a comma-separated string.  If no flags
+ *	are set, return the default string.
+ */
+char *
+flags_to_string(u_long flags, const char *def)
+{
+	char string[128];
+	const char *prefix;
+
+	string[0] = '\0';
+	prefix = NULL;
+#if HAVE_STRUCT_STAT_ST_FLAGS
+	if (flags & UF_APPEND)
+		SAPPEND("uappnd");
+	if (flags & UF_IMMUTABLE)
+		SAPPEND("uchg");
+	if (flags & UF_NODUMP)
+		SAPPEND("nodump");
+	if (flags & UF_OPAQUE)
+		SAPPEND("opaque");
+	if (flags & SF_APPEND)
+		SAPPEND("sappnd");
+	if (flags & SF_ARCHIVED)
+		SAPPEND("arch");
+	if (flags & SF_IMMUTABLE)
+		SAPPEND("schg");
+#ifdef SF_SNAPSHOT
+	if (flags & SF_SNAPSHOT)
+		SAPPEND("snap");
+#endif
+#endif
+	if (prefix != NULL)
+		return strdup(string);
+	return strdup(def);
+}
+
+#define	TEST(a, b, f) {							\
+	if (!strcmp(a, b)) {						\
+		if (clear) {						\
+			if (clrp)					\
+				*clrp |= (f);				\
+			if (setp)					\
+				*setp &= ~(f);				\
+		} else {						\
+			if (setp)					\
+				*setp |= (f);				\
+			if (clrp)					\
+				*clrp &= ~(f);				\
+		}							\
+		break;							\
+	}								\
+}
+
+/*
+ * string_to_flags --
+ *	Take string of arguments and return stat flags.  Return 0 on
+ *	success, 1 on failure.  On failure, stringp is set to point
+ *	to the offending token.
+ */
+int
+string_to_flags(char **stringp, u_long *setp, u_long *clrp)
+{
+	int clear;
+	char *string, *p;
+
+	if (setp)
+		*setp = 0;
+	if (clrp)
+		*clrp = 0;
+
+#if HAVE_STRUCT_STAT_ST_FLAGS
+	string = *stringp;
+	while ((p = strsep(&string, "\t ,")) != NULL) {
+		clear = 0;
+		*stringp = p;
+		if (*p == '\0')
+			continue;
+		if (p[0] == 'n' && p[1] == 'o') {
+			clear = 1;
+			p += 2;
+		}
+		switch (p[0]) {
+		case 'a':
+			TEST(p, "arch", SF_ARCHIVED);
+			TEST(p, "archived", SF_ARCHIVED);
+			return (1);
+		case 'd':
+			clear = !clear;
+			TEST(p, "dump", UF_NODUMP);
+			return (1);
+		case 'n':
+				/*
+				 * Support `nonodump'. Note that
+				 * the state of clear is not changed.
+				 */
+			TEST(p, "nodump", UF_NODUMP);
+			return (1);
+		case 'o':
+			TEST(p, "opaque", UF_OPAQUE);
+			return (1);
+		case 's':
+			TEST(p, "sappnd", SF_APPEND);
+			TEST(p, "sappend", SF_APPEND);
+			TEST(p, "schg", SF_IMMUTABLE);
+			TEST(p, "schange", SF_IMMUTABLE);
+			TEST(p, "simmutable", SF_IMMUTABLE);
+			return (1);
+		case 'u':
+			TEST(p, "uappnd", UF_APPEND);
+			TEST(p, "uappend", UF_APPEND);
+			TEST(p, "uchg", UF_IMMUTABLE);
+			TEST(p, "uchange", UF_IMMUTABLE);
+			TEST(p, "uimmutable", UF_IMMUTABLE);
+			return (1);
+		default:
+			return (1);
+		}
+	}
+#endif
+
+	return (0);
+}
diff --git a/usr.sbin/mtree/verify.c b/usr.sbin/mtree/verify.c
index 2e6ca80a4c..b320b32287 100644
--- a/usr.sbin/mtree/verify.c
+++ b/usr.sbin/mtree/verify.c
@@ -1,3 +1,5 @@
+/*	$NetBSD: verify.c,v 1.46 2015/01/23 20:28:24 christos Exp $	*/
+
 /*-
  * Copyright (c) 1990, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -25,21 +27,34 @@
  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
- *
- * @(#)verify.c	8.1 (Berkeley) 6/6/93
- * $FreeBSD: src/usr.sbin/mtree/verify.c,v 1.10.2.2 2001/01/12 19:17:18 phk Exp $
  */
 
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#endif
+
+#include <sys/cdefs.h>
+#if defined(__RCSID) && !defined(lint)
+#if 0
+static char sccsid[] = "@(#)verify.c	8.1 (Berkeley) 6/6/93";
+#else
+__RCSID("$NetBSD: verify.c,v 1.46 2015/01/23 20:28:24 christos Exp $");
+#endif
+#endif /* not lint */
+
 #include <sys/param.h>
 #include <sys/stat.h>
+
+#if ! HAVE_NBTOOL_CONFIG_H
 #include <dirent.h>
-#include <err.h>
+#endif
+
 #include <errno.h>
-#include <fts.h>
 #include <fnmatch.h>
 #include <stdio.h>
+#include <string.h>
 #include <unistd.h>
-#include "mtree.h"
+
 #include "extern.h"
 
 static NODE *root;
@@ -49,11 +64,11 @@ static void	miss(NODE *, char *);
 static int	vwalk(void);
 
 int
-verify(void)
+verify(FILE *fi)
 {
 	int rval;
 
-	root = spec();
+	root = spec(fi);
 	rval = vwalk();
 	miss(root, path);
 	return (rval);
@@ -66,19 +81,24 @@ vwalk(void)
 	FTSENT *p;
 	NODE *ep, *level;
 	int specdepth, rval;
-	char *argv[2], dot[] = ".";
-
+	char *argv[2];
+	char  dot[] = ".";
 	argv[0] = dot;
 	argv[1] = NULL;
+
 	if ((t = fts_open(argv, ftsoptions, NULL)) == NULL)
-		err(1, "line %d: fts_open", lineno);
+		mtree_err("fts_open: %s", strerror(errno));
 	level = root;
 	specdepth = rval = 0;
-	while ((p = fts_read(t))) {
+	while ((p = fts_read(t)) != NULL) {
 		if (check_excludes(p->fts_name, p->fts_path)) {
 			fts_set(t, p, FTS_SKIP);
 			continue;
 		}
+		if (!find_only(p->fts_path)) {
+			fts_set(t, p, FTS_SKIP);
+			continue;
+		}
 		switch(p->fts_info) {
 		case FTS_D:
 		case FTS_SL:
@@ -86,7 +106,8 @@ vwalk(void)
 		case FTS_DP:
 			if (specdepth > p->fts_level) {
 				for (level = level->parent; level->prev;
-				      level = level->prev);
+				    level = level->prev)
+					continue;
 				--specdepth;
 			}
 			continue;
@@ -110,22 +131,30 @@ vwalk(void)
 				if ((ep->flags & F_NOCHANGE) == 0 &&
 				    compare(ep, p))
 					rval = MISMATCHEXIT;
-				if (ep->flags & F_IGN)
-					fts_set(t, p, FTS_SKIP);
-				else if (ep->child && ep->type == F_DIR &&
+				if (!(ep->flags & F_IGN) &&
+				    ep->type == F_DIR &&
 				    p->fts_info == FTS_D) {
-					level = ep->child;
-					++specdepth;
-				}
+					if (ep->child) {
+						level = ep->child;
+						++specdepth;
+					}
+				} else
+					fts_set(t, p, FTS_SKIP);
 				break;
 			}
 
 		if (ep)
 			continue;
-extra:
-		if (!eflag) {
-			printf("%s extra", RP(p));
+ extra:
+		if (!eflag && !(dflag && p->fts_info == FTS_SL)) {
+			printf("extra: %s", RP(p));
 			if (rflag) {
+#if HAVE_STRUCT_STAT_ST_FLAGS
+				if (rflag > 1 &&
+				    lchflags(p->fts_accpath, 0) == -1)
+					printf(" (chflags %s)",
+					    strerror(errno));
+#endif
 				if ((S_ISDIR(p->fts_statp->st_mode)
 				    ? rmdir : unlink)(p->fts_accpath)) {
 					printf(", not removed: %s",
@@ -149,79 +178,136 @@ miss(NODE *p, char *tail)
 	int create;
 	char *tp;
 	const char *type;
+	u_int32_t flags;
 
 	for (; p; p = p->next) {
+		if (p->flags & F_OPT && !(p->flags & F_VISIT))
+			continue;
 		if (p->type != F_DIR && (dflag || p->flags & F_VISIT))
 			continue;
 		strcpy(tail, p->name);
 		if (!(p->flags & F_VISIT)) {
-			/* Don't print missing message if file exists as a
+			/* Don't print missing message if file exists as a 
 			   symbolic link and the -q flag is set. */
 			struct stat statbuf;
- 
-			if (qflag && stat(path, &statbuf) == 0)
+
+			if (qflag && stat(path, &statbuf) == 0 &&
+			    S_ISDIR(statbuf.st_mode))
 				p->flags |= F_VISIT;
 			else
-				printf("%s missing", path);
+				(void)printf("%s missing", path);
 		}
-		if (p->type != F_DIR && p->type != F_LINK) {
+		switch (p->type) {
+		case F_BLOCK:
+		case F_CHAR:
+			type = "device";
+			break;
+		case F_DIR:
+			type = "directory";
+			break;
+		case F_LINK:
+			type = "symlink";
+			break;
+		default:
 			putchar('\n');
 			continue;
 		}
 
 		create = 0;
-		if (p->type == F_LINK)
-			type = "symlink";
-		else
-			type = "directory";
 		if (!(p->flags & F_VISIT) && uflag) {
+			if (mtree_Wflag || p->type == F_LINK)
+				goto createit;
 			if (!(p->flags & (F_UID | F_UNAME)))
-				printf(" (%s not created: user not specified)", type);
+			    printf(
+				" (%s not created: user not specified)", type);
 			else if (!(p->flags & (F_GID | F_GNAME)))
-				printf(" (%s not created: group not specified)", type);
-			else if (p->type == F_LINK) {
-				if (symlink(p->slink, path))
-					printf(" (symlink not created: %s)\n",
+			    printf(
+				" (%s not created: group not specified)", type);
+			else if (!(p->flags & F_MODE))
+			    printf(
+				" (%s not created: mode not specified)", type);
+			else
+ createit:
+			switch (p->type) {
+			case F_BLOCK:
+			case F_CHAR:
+				if (mtree_Wflag)
+					continue;
+				if (!(p->flags & F_DEV))
+					printf(
+				    " (%s not created: device not specified)",
+					    type);
+				else if (mknod(path,
+				    p->st_mode | nodetoino(p->type),
+				    p->st_rdev) == -1)
+					printf(" (%s not created: %s)\n",
+					    type, strerror(errno));
+				else
+					create = 1;
+				break;
+			case F_LINK:
+				if (!(p->flags & F_SLINK))
+					printf(
+				    " (%s not created: link not specified)\n",
+					    type);
+				else if (symlink(p->slink, path))
+					printf(
+					    " (%s not created: %s)\n",
+					    type, strerror(errno));
+				else
+					create = 1;
+				break;
+			case F_DIR:
+				if (mkdir(path, S_IRWXU|S_IRWXG|S_IRWXO))
+					printf(" (not created: %s)",
 					    strerror(errno));
 				else
-					printf(" (created)\n");
-				if (lchown(path, p->st_uid, p->st_gid))
-					printf("%s: user/group not modified: %s\n",
-					    path, strerror(errno));
-				continue;
-			} else if (!(p->flags & F_MODE))
-			    printf(" (directory not created: mode not specified)");
-			else if (mkdir(path, S_IRWXU))
-				printf(" (directory not created: %s)",
-				    strerror(errno));
-			else {
-				create = 1;
-				printf(" (created)");
+					create = 1;
+				break;
+			default:
+				mtree_err("can't create create %s",
+				    nodetype(p->type));
 			}
 		}
-		if (!(p->flags & F_VISIT))
+		if (create)
+			printf(" (created)");
+		if (p->type == F_DIR) {
+			if (!(p->flags & F_VISIT))
+				putchar('\n');
+			for (tp = tail; *tp; ++tp)
+				continue;
+			*tp = '/';
+			miss(p->child, tp + 1);
+			*tp = '\0';
+		} else
 			putchar('\n');
 
-		for (tp = tail; *tp; ++tp);
-		*tp = '/';
-		miss(p->child, tp + 1);
-		*tp = '\0';
-
-		if (!create)
+		if (!create || mtree_Wflag)
 			continue;
-		if (chown(path, p->st_uid, p->st_gid)) {
+		if ((p->flags & (F_UID | F_UNAME)) &&
+		    (p->flags & (F_GID | F_GNAME)) &&
+		    (lchown(path, p->st_uid, p->st_gid))) {
 			printf("%s: user/group/mode not modified: %s\n",
 			    path, strerror(errno));
 			printf("%s: warning: file mode %snot set\n", path,
 			    (p->flags & F_FLAGS) ? "and file flags " : "");
 			continue;
 		}
-		if (chmod(path, p->st_mode))
-			printf("%s: permissions not set: %s\n",
-			    path, strerror(errno));
-		if ((p->flags & F_FLAGS) && p->st_flags &&
-		    chflags(path, p->st_flags))
-			printf("%s: file flags not set: %s\n",
-			    path, strerror(errno));
+		if (p->flags & F_MODE) {
+			if (lchmod(path, p->st_mode))
+				printf("%s: permissions not set: %s\n",
+				    path, strerror(errno));
+		}
+#if HAVE_STRUCT_STAT_ST_FLAGS
+		if ((p->flags & F_FLAGS) && p->st_flags) {
+			if (iflag)
+				flags = p->st_flags;
+			else
+				flags = p->st_flags & ~SP_FLGS;
+			if (lchflags(path, flags))
+				printf("%s: file flags not set: %s\n",
+				    path, strerror(errno));
+		}
+#endif	/* HAVE_STRUCT_STAT_ST_FLAGS */
 	}
 }
-- 
2.17.1

